// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UObject.h"
#include <memory>

using std::shared_ptr;

namespace Sourcify
{	
	class ISCW_FProperty;

	class ISCW_UPropertyWrapper : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UPropertyWrapper() = default;
		
		virtual shared_ptr<ISCW_UPropertyWrapper> ToUPropertyWrapperPtr() = 0;
		virtual shared_ptr<const ISCW_UPropertyWrapper> ToUPropertyWrapperPtr() const = 0;

		virtual shared_ptr<const ISCW_FProperty> GetProperty() const = 0;
		virtual shared_ptr<ISCW_FProperty> GetProperty() = 0;
	};

	using ISCW_UPropertyWrapperConstPtr = shared_ptr<const ISCW_UPropertyWrapper>;
	using ISCW_UPropertyWrapperPtr = shared_ptr<ISCW_UPropertyWrapper>;
} // namespace Sourcify